//
// Patron pour la generation d'une classe derivee dans ROOT
// FDataReader derive de TNamed
//

#ifndef FDataReader_h
#define FDataReader_h

#include "TNamed.h"
#include "THashList.h"
#include "FDevice.h"
#include "TEnv.h"

class FDataReader : public TNamed {

  //protected:
  //  FDevice *device;
  //  TList   *lod;

  public:
    static void Make(Char_t const *cn="MyDataReader");

  protected:
    THashList *listOfParamsBruts;

  protected:
    virtual void Init(void);       // initialisation

  public:
    FDataReader(void);    // constructeur par defaut
    FDataReader(const FDataReader &ap); // constructeur par copie

    ~FDataReader(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FDataReader& operator = (const FDataReader &hp); // operateur =

    virtual void InitListOfParamsBruts(void)=0;
    virtual const THashList *GetListOfParamsBruts(void) {return listOfParamsBruts;}
    virtual void SetParamBrutsValues(void)=0;
    virtual void SetDevice(FDevice *dev=0) {;}
    virtual const FDevice *GetDevice(void) {return 0;}
    virtual Bool_t IsOk(void);
    virtual Bool_t NeedDevice(void){return kFALSE;}

    virtual void InitFromEnv(TEnv *env);

    virtual const Char_t *GetDataReaderInfo(void) { return (const Char_t *)"";}
    virtual void ResetDataReaderInfo(void) {;}

    ClassDef(FDataReader,1)

};

#endif

