// 
// Patron pour la generation d'une classe derivee dans ROOT
// FDiffCounter derive de FParam
// 
 
#ifndef FDiffCounter_h 
#define FDiffCounter_h 
 
#include "FRateCounter.h" 
 
class FDiffCounter : public FRateCounter { 
 
   protected:
        Bool_t   refBaseOK;
	Bool_t   countsBaseOK;
	Double_t refBase;
	Double_t countsBase;
   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FDiffCounter(void);    // constructeur par defaut 
	FDiffCounter(const FDiffCounter &ap); // constructeur par copie 
	
	~FDiffCounter(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FDiffCounter& operator = (const FDiffCounter &hp); // operateur = 
 
 	virtual void    WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin,TList *lop);
	virtual void	SetParam(FParam *p=0);
	virtual FParam *GetParam(void){return param;}
	virtual void	SetParamRef(FParam *p=0);
	virtual FParam *GetParamRef(void){return paramRef;}
	virtual void	SetRefRate(Double_t n=1000)
	 {refRate=n;ref=0;counts=0;valRate=-1.;}
	virtual void 	IncrementCounter(void);

    ClassDef(FDiffCounter,1)
 
}; 
 
#endif 
 
