//
// Patron pour la generation d'une classe derivee dans ROOT
// FH2F derive de TH1F
//

#ifndef FH2F_h
#define FH2F_h

#include "TH2F.h"
#include "FH2Att.h"

// class FH2F : public TH2F, public FHistAtt {
class FH2F : public TH2F, public FH2Att {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FH2F(void);    // constructeur par defaut
    FH2F(const char* name, const char* title, Int_t nbinsx, Axis_t xlow, Axis_t xup, Int_t nbinsy, Axis_t ylow, Axis_t yup);
    FH2F(const char* name, const char* title, Int_t nbinsx, const Double_t* xbins, Int_t nbinsy, Axis_t ylow, Axis_t yup);
    FH2F(const char* name, const char* title, Int_t nbinsx, Axis_t xlow, Axis_t xup, Int_t nbinsy, const Double_t* ybins);
    FH2F(const char* name, const char* title, Int_t nbinsx, const Double_t* xbins, Int_t nbinsy, const Double_t* ybins);
    FH2F(const char* name, const char* title, Int_t nbinsx, const Float_t* xbins, Int_t nbinsy, const Float_t* ybins);
    FH2F(const FH2F &ap); // constructeur par copie

    ~FH2F(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FH2F& operator = (const FH2F &hp); // operateur =

    // 	virtual void SetParamX(FParam *p);
    // 	virtual FParam *GetParamX(void);
    // 	virtual void SetParamY(FParam *p);
    // 	virtual FParam *GetParamY(void);
    // 	virtual void FillHist(Stat_t w=1.);
    //
    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    ClassDef(FH2F,1)

};

#endif

