//
// Patron pour la generation d'une classe derivee dans ROOT
// FHCtrl2D derive de TH2D
//

#ifndef FHCtrl2D_h
#define FHCtrl2D_h

#include "TH2D.h"
#include "FCtrl2DAtt.h"

class FHCtrl2D : public TH2D, public FCtrl2DAtt {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FHCtrl2D(void);    // constructeur par defaut
    FHCtrl2D(const char* name, const char* title, Bool_t vert=kTRUE);
    FHCtrl2D(const char* name, const char* title,
        Int_t n, Double_t min,Double_t max, Bool_t vert=kTRUE);
    FHCtrl2D(const FHCtrl2D &ap); // constructeur par copie

    ~FHCtrl2D(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FHCtrl2D& operator = (const FHCtrl2D &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    ClassDef(FHCtrl2D,1)

};

#endif

