// 
// Patron pour la generation d'une classe derivee dans ROOT
// FIPEventGenerator derive de FNetDataServer
// 
 
#ifndef FIPEventGenerator_h 
#define FIPEventGenerator_h 
 
#include "TObject.h" 
#include "FIPConnection.h" 
#include "Riostream.h" 

#define MAXBUFFERSIZEEGIP 8192
#define MAXSIZE 32768
 
class FIPEventGenerator : public TObject { 
 
   protected:
   	FIPConnection *sock;
   	UChar_t  buf[MAXSIZE];
	Int_t   maxEventSize;
	Long_t  numEvt;
	Long_t  nbuf;
	Bool_t  tcp;
	Bool_t  swap;
	
	ofstream out;
	Int_t   nbBlocksToWrite;
	Bool_t  wFile;
	   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FIPEventGenerator(void);    // constructeur par defaut 
	FIPEventGenerator(const FIPEventGenerator &ap); // constructeur par copie 
	
	~FIPEventGenerator(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FIPEventGenerator& operator = (const FIPEventGenerator &hp); // operateur = 

	virtual void LaunchServer(Int_t port=9090, Char_t const *prot="TCP");
	virtual void WaitClient(void);
	virtual void MainLoop(void);
	virtual void TerminateServer(void);
        virtual void BuildBuffer(void);
	virtual Int_t BuildNewEvent(UChar_t *EvtBuf);
	
	virtual Long_t GetNbOfBuffers(void) {return nbuf;}
	virtual Long_t GetEventNumber(void) {return numEvt;}
	virtual Int_t GetMaxBufSize(void) {return MAXBUFFERSIZEEGIP;}
	virtual void SetSwap(Bool_t s=kTRUE) {swap=s;};
	
	virtual void WriteToFile(const Char_t *fn="DataFile.dat");
	virtual void SetBlocksToWrite(Int_t nb=20000){nbBlocksToWrite=nb;}
 
    ClassDef(FIPEventGenerator,1)
 
}; 
 
#endif 
 
