// 
// Patron pour la generation d'une classe derivee dans ROOT
// FNetEventGenerator derive de FNetDataServer
// 
 
#ifndef FNetEventGenerator_h 
#define FNetEventGenerator_h 
 
#include "FNetDataServer.h" 

#define MAXBUFFERSIZE 16384
 
class FNetEventGenerator : public FNetDataServer { 
 
   protected:
   	UChar_t  buf[MAXBUFFERSIZE];
	Int_t   maxEventSize;
	Long_t  numEvt;
	Long_t  nbuf;
	   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FNetEventGenerator(void);    // constructeur par defaut 
	FNetEventGenerator(const FNetEventGenerator &ap); // constructeur par copie 
	
	~FNetEventGenerator(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FNetEventGenerator& operator = (const FNetEventGenerator &hp); // operateur = 

	virtual void AddSocket(void);
	virtual void ProcessMessage(TMessage *m);
        virtual void BuildBuffer(void);
	virtual Int_t BuildNewEvent(UChar_t *EvtBuf);
	
	virtual Long_t GetNbOfBuffers(void) {return nbuf;}
	virtual Long_t GetEventNumber(void) {return numEvt;}
 
    ClassDef(FNetEventGenerator,1)
 
}; 
 
#endif 
 
