// 
// Patron pour la generation d'une classe derivee dans ROOT
// FParamIndex derive de FParam
// 
 
#ifndef FParamIndex_h 
#define FParamIndex_h 
 
#include "FParam.h" 
 
class FParamIndex : public FParam { 
 
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FParamIndex(void);    // constructeur par defaut 
	FParamIndex(const FParamIndex &ap); // constructeur par copie 
	
	~FParamIndex(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FParamIndex& operator = (const FParamIndex &hp); // operateur = 
 
 	virtual Double_t GetValue(Int_t i=0) const {return (Double_t)i;}
	virtual void    SetValue(Double_t val, Int_t i=0) {;}
	virtual Bool_t 	IsOn(void) const {return kTRUE;}
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);

    ClassDef(FParamIndex,1)
 
}; 
 
#endif 
 
