//
// Patron pour la generation d'une classe derivee dans ROOT
// FProfile derive de TProfile
//

#ifndef FProfile_h
#define FProfile_h

#include "TProfile.h"

#include "FProfileAtt.h"

class FProfile : public TProfile, public FProfileAtt {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FProfile(void);    // constructeur par defaut
    FProfile(const char* name, const char* title, Int_t nbinsx, Axis_t xlow, Axis_t xup, Option_t* option);
    FProfile(const char* name, const char* title, Int_t nbinsx, Axis_t xlow, Axis_t xup, Axis_t ylow, Axis_t yup, Option_t* option);
    FProfile(const char* name, const char* title, Int_t nbinsx, const Float_t* xbins, Option_t* option);
    FProfile(const char* name, const char* title, Int_t nbinsx, const Double_t* xbins, Option_t* option);
    FProfile(const char* name, const char* title, Int_t nbinsx, const Double_t* xbins, Axis_t ylow, Axis_t yup, Option_t* option);
    FProfile(const FProfile &ap); // constructeur par copie

    ~FProfile(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FProfile& operator = (const FProfile &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    ClassDef(FProfile,1)

};

#endif

