// 
// Patron pour la generation d'une classe derivee dans ROOT
// FRawScaleAtt derive de FScaleAtt
// 
 
#ifndef FRawScaleAtt_h 
#define FRawScaleAtt_h 
 
#include "FScaleAtt.h" 
 
class FRawScaleAtt : public FScaleAtt { 
 
   public:	 
   	FRawScaleAtt(void);    // constructeur par defaut 
	FRawScaleAtt(const FRawScaleAtt &ap); // constructeur par copie 
	
	~FRawScaleAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FRawScaleAtt& operator = (const FRawScaleAtt &hp); // operateur = 
	virtual void FillHist(Stat_t w=1.);

	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);
	

    ClassDef(FRawScaleAtt,1)
 
}; 
 
#endif 
 
