//
// Patron pour la generation d'une classe derivee dans ROOT
// FTimeProfile derive de TProfile
//

#ifndef FTimeProfile_h
#define FTimeProfile_h

#include "TProfile.h"

#include "FTimeProfileAtt.h"

class FTimeProfile : public TProfile, public FTimeProfileAtt {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FTimeProfile(void);    // constructeur par defaut
    FTimeProfile(const char* name, const char* title, Int_t nbinsx, Option_t* option);
    FTimeProfile(const char* name, const char* title, Int_t nbinsx, Axis_t ylow, Axis_t yup, Option_t* option);
    FTimeProfile(const FTimeProfile &ap); // constructeur par copie

    ~FTimeProfile(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FTimeProfile& operator = (const FTimeProfile &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    ClassDef(FTimeProfile,1)

};

#endif

